Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiKaonZeroInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiKaonZeroInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiKaonZeroInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiKaonZeroInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiLambdaInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiLambdaInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiLambdaInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiLambdaInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiNeutronInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiNeutronInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiNeutronInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiNeutronInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiOmegaMinusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiOmegaMinusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiOmegaMinusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiOmegaMinusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiProtonInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiProtonInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiProtonInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiProtonInelastic.cc,v 1.14 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaMinusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaMinusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaMinusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiSigmaMinusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaPlusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaPlusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaPlusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiSigmaPlusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaZeroInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaZeroInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiSigmaZeroInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiSigmaZeroInelastic.cc,v 1.10 2006/06/29 20:30:08 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiXiMinusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiXiMinusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiXiMinusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiXiMinusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiXiZeroInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiXiZeroInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEAntiXiZeroInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEAntiXiZeroInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonMinusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonMinusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonMinusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEKaonMinusInelastic.cc,v 1.14 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonPlusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonPlusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonPlusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEKaonPlusInelastic.cc,v 1.14 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEKaonZeroInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroLongInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroLongInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroLongInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEKaonZeroLongInelastic.cc,v 1.10 2006/06/29 20:30:22 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroShortInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroShortInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEKaonZeroShortInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEKaonZeroShortInelastic.cc,v 1.10 2006/06/29 20:30:24 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HELambdaInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HELambdaInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HELambdaInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HELambdaInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HENeutronInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HENeutronInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HENeutronInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HENeutronInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEOmegaMinusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEOmegaMinusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEOmegaMinusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEOmegaMinusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEPionMinusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEPionMinusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEPionMinusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEPionMinusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 // 11-OCT-2007 F.W. Jones: fixed incorrect Imax (should be Imin) in
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEPionPlusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEPionPlusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEPionPlusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEPionPlusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEPlot.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEPlot.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEPlot.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEPlot.cc,v 1.11 2006/06/29 20:30:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEProtonInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEProtonInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEProtonInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEProtonInelastic.cc,v 1.14 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaMinusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaMinusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaMinusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HESigmaMinusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaPlusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaPlusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaPlusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HESigmaPlusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaZeroInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaZeroInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HESigmaZeroInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HESigmaZeroInelastic.cc,v 1.11 2006/06/29 20:30:44 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEVector.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEVector.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEVector.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEVector.cc,v 1.20 2006/11/22 23:52:32 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEXiMinusInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEXiMinusInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEXiMinusInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEXiMinusInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/high_energy/src/G4HEXiZeroInelastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/high_energy/src/G4HEXiZeroInelastic.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/high_energy/src/G4HEXiZeroInelastic.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HEXiZeroInelastic.cc,v 1.15 2008/03/17 20:49:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
Index: trunk/source/processes/hadronic/models/im_r_matrix/History
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/History	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/History	(revision 1228)
@@ -14,4 +14,17 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+30-Nov-2009 Gunter Folger                hadr-im_r-V09-02-02
+-  Fix compilation error in gcc 4.3 (typeinfo)
+
+20-Nov-2009 Gunter Folger                hadr-im_r-V09-02-01
+-  Reduce usage of strings. Maps of cross sections use G4Particledefinition
+   in place of particle name
+
+19-Nov-2009 Gunter Folger/Tatsumi Koi    hadr-im_r-V09-02-00
+-  G4CollisionComposite.cc: Fix for reproducability provided by Tatsumi. 
+   Removed the dependance of the energy grid of the cross section set
+   on the order of the particles by forcing heavier particle to be at rest
+   when caching the cross section.
 
 8-Dec-2008  Gunter Folger           hadr-im_r-V09-01-01
Index: trunk/source/processes/hadronic/models/im_r_matrix/include/G4CollisionInitialState.hh
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/include/G4CollisionInitialState.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/include/G4CollisionInitialState.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CollisionInitialState.hh,v 1.4.4.2 2006/06/29 20:31:14 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // $Id: G4CollisionInitialState.hh,v 1.0 1998/06/30
Index: trunk/source/processes/hadronic/models/im_r_matrix/include/G4ListOfCollisions.hh
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/include/G4ListOfCollisions.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/include/G4ListOfCollisions.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ListOfCollisions.hh,v 1.1.4.2 2006/06/29 20:35:35 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // $Id: G4ListOfCollisions.hh,v 1.0 1998/06/30
Index: trunk/source/processes/hadronic/models/im_r_matrix/include/G4VCrossSectionSource.hh
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/include/G4VCrossSectionSource.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/include/G4VCrossSectionSource.hh	(revision 1228)
@@ -76,5 +76,5 @@
                    G4double eParam, G4double power) const;
 
-  G4String FindKeyParticle(const G4KineticTrack& trk1,const G4KineticTrack& trk2) const;
+  G4ParticleDefinition * FindKeyParticle(const G4KineticTrack& trk1,const G4KineticTrack& trk2) const;
   
   // Transverse pion mass
Index: trunk/source/processes/hadronic/models/im_r_matrix/include/G4XNNElasticLowE.hh
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/include/G4XNNElasticLowE.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/include/G4XNNElasticLowE.hh	(revision 1228)
@@ -78,5 +78,5 @@
   static const G4double _eStepLog;
 
-  std::map <G4String, G4PhysicsVector*, std::less<G4String> > xMap;
+  std::map <G4ParticleDefinition *, G4PhysicsVector*, std::less<G4ParticleDefinition *> > xMap;
 
   G4double _eMin;
Index: trunk/source/processes/hadronic/models/im_r_matrix/include/G4XNNTotalLowE.hh
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/include/G4XNNTotalLowE.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/include/G4XNNTotalLowE.hh	(revision 1228)
@@ -66,6 +66,7 @@
   static const G4int tableSize;
 
-  std::map <G4String, G4LowEXsection *, std::less<G4String> > theCrossSections;
-  typedef std::map <G4String, G4LowEXsection*, std::less<G4String> > LowEMap;
+  std::map <G4ParticleDefinition *, G4LowEXsection *,
+  std::less<G4ParticleDefinition *> > theCrossSections;
+  typedef std::map <G4ParticleDefinition *, G4LowEXsection*, std::less<G4ParticleDefinition *> > LowEMap;
 
 };
Index: trunk/source/processes/hadronic/models/im_r_matrix/include/G4XPDGElastic.hh
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/include/G4XPDGElastic.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/include/G4XPDGElastic.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4XPDGElastic.hh,v 1.2 2006/06/29 20:36:48 gunter Exp $ //
+// $Id: G4XPDGElastic.hh,v 1.2.2.1 2009/11/20 16:25:08 gunter Exp $ //
 // ---------------------------------------------------------------
 //      GEANT4 Class file
@@ -48,5 +48,5 @@
 #include <map>
 
-typedef std::pair<G4String,G4String> G4StringPair;
+typedef std::pair<G4ParticleDefinition *,G4ParticleDefinition *> G4pDefPair;
 
 class G4KineticTrack;
@@ -96,7 +96,7 @@
   static const G4double npbarPDGFit[7];
 
-  std::map <G4StringPair, std::vector<G4double>, std::less<G4StringPair> > xMap;
+  std::map <G4pDefPair, std::vector<G4double>, std::less<G4pDefPair> > xMap;
 
-  typedef std::map <G4StringPair, std::vector<G4double>, std::less<G4StringPair> > PairDoubleMap;
+  typedef std::map <G4pDefPair, std::vector<G4double>, std::less<G4pDefPair> > PairDoubleMap;
 
   //  G4double pMinFit;
Index: trunk/source/processes/hadronic/models/im_r_matrix/include/G4XPDGTotal.hh
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/include/G4XPDGTotal.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/include/G4XPDGTotal.hh	(revision 1228)
@@ -48,5 +48,5 @@
 #include <vector>
 
-typedef std::pair<G4String,G4String> G4StringPair;
+typedef std::pair<G4ParticleDefinition *,G4ParticleDefinition *> G4pDefPair;
 
 class G4KineticTrack;
@@ -97,6 +97,6 @@
   static const G4double gammagammaPDGFit[5];
 
-  std::map <G4StringPair, std::vector<G4double>, std::less<G4StringPair> > xMap;
-  typedef std::map <G4StringPair, std::vector<G4double>, std::less<G4StringPair> > PairDoubleMap;
+  std::map <G4pDefPair, std::vector<G4double>, std::less<G4pDefPair> > xMap;
+  typedef std::map <G4pDefPair, std::vector<G4double>, std::less<G4pDefPair> > PairDoubleMap;
 
   //  G4double eMinFit;
Index: trunk/source/processes/hadronic/models/im_r_matrix/src/G4CollisionManager.cc
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/src/G4CollisionManager.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/src/G4CollisionManager.cc	(revision 1228)
@@ -27,4 +27,7 @@
 #include "G4HadronicException.hh"
 #include "G4CollisionInitialState.hh"
+#include "G4BCAction.hh"
+
+#include <typeinfo>
 
 G4CollisionManager::G4CollisionManager()
@@ -178,8 +181,15 @@
   {
     collision = *i;
+    G4int tgtPdg=collision->GetTarget() ?
+	   collision->GetTarget()->GetDefinition()->GetPDGEncoding() : 0;
     G4cout << "  collision " << collision << " time: "
 	   << collision->GetCollisionTime()/second << " proj: "
-	   << collision->GetPrimary() << " trgt: "
-	   << collision->GetTarget() << G4endl;
+	   << collision->GetPrimary() << "/pdg="
+	   << collision->GetPrimary()->GetDefinition()->GetPDGEncoding()
+	   << " trgt: "
+	   << collision->GetTarget() << "/pdg="
+	   << tgtPdg
+	   << " Collision type: "<< typeid(*collision->GetGenerator()).name()
+	   << G4endl;
   }
 }
Index: trunk/source/processes/hadronic/models/im_r_matrix/src/G4Scatterer.cc
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/src/G4Scatterer.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/src/G4Scatterer.cc	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4Scatterer.cc,v 1.13.2.4 2006/06/29 20:40:31 gunter Exp $ //
+// $Id: G4Scatterer.cc,v 1.13.2.4.2.1 2009/11/20 16:25:08 gunter Exp $ //
 //
 
@@ -126,6 +126,4 @@
 //	    << G4endl;
 
-	   // global optimization
-//	   static const G4double maxCrossSection = 500*millibarn;
 	   if(pi*distance>maxCrossSection) return time;
 	   
Index: trunk/source/processes/hadronic/models/im_r_matrix/src/G4VCrossSectionSource.cc
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/src/G4VCrossSectionSource.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/src/G4VCrossSectionSource.cc	(revision 1228)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-// $Id: G4VCrossSectionSource.cc,v 1.5 2006/08/19 21:50:47 dennis Exp $ //
+// $Id: G4VCrossSectionSource.cc,v 1.5.2.1 2009/11/20 16:25:08 gunter Exp $ //
 //
 
@@ -46,8 +46,8 @@
 
 
-G4String G4VCrossSectionSource::
+G4ParticleDefinition * G4VCrossSectionSource::
 FindKeyParticle(const G4KineticTrack& trk1,const G4KineticTrack& trk2) const
 {
-  G4String result;
+  G4ParticleDefinition * result;
   
   G4ParticleDefinition * p1 = trk1.GetDefinition();
@@ -57,10 +57,10 @@
       (p1==G4Neutron::Neutron() && p2==G4Neutron::Neutron()) )
   {
-    result = G4Proton::Proton()->GetParticleName();
+    result = G4Proton::Proton();
   }
   else if( (p1==G4Neutron::Neutron() && p2==G4Proton::Proton()) ||
            (p2==G4Neutron::Neutron() && p1==G4Proton::Proton()) )
   {
-    result = G4Neutron::Neutron()->GetParticleName();
+    result = G4Neutron::Neutron();
   }
   else
Index: trunk/source/processes/hadronic/models/im_r_matrix/src/G4XNNElasticLowE.cc
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/src/G4XNNElasticLowE.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/src/G4XNNElasticLowE.cc	(revision 1228)
@@ -111,6 +111,6 @@
       np->PutValue(i,value);
     }
-  xMap[G4Proton::ProtonDefinition()->GetParticleName()] = pp;
-  xMap[G4Neutron::NeutronDefinition()->GetParticleName()] = np;
+  xMap[G4Proton::ProtonDefinition()] = pp;
+  xMap[G4Neutron::NeutronDefinition()] = np;
 }
 
@@ -118,8 +118,6 @@
 G4XNNElasticLowE::~G4XNNElasticLowE()
 {
-  G4String name_proton = "proton";
-  G4String name_neutron = "neutron";
-  delete xMap[name_proton];
-  delete xMap[name_neutron];
+  delete xMap[G4Proton::ProtonDefinition()];
+  delete xMap[G4Neutron::NeutronDefinition()];
 }
 
@@ -144,7 +142,7 @@
   G4bool dummy = false;
 
-  G4String key = FindKeyParticle(trk1,trk2);
-
-  typedef std::map <G4String, G4PhysicsVector*, std::less<G4String> > StringPhysMap;
+  G4ParticleDefinition * key = FindKeyParticle(trk1,trk2);
+
+  typedef std::map <G4ParticleDefinition *, G4PhysicsVector*, std::less<G4ParticleDefinition *> > StringPhysMap;
 
   if (xMap.find(key)!= xMap.end())
@@ -154,5 +152,5 @@
       for (iter = xMap.begin(); iter != xMap.end(); ++iter)
 	{
-	  G4String str = (*iter).first;
+	  G4ParticleDefinition * str = (*iter).first;
           if (str == key)
 	    {
@@ -166,4 +164,6 @@
                   sigma = physVector->GetValue(_eMin,dummy);
                 }
+		//G4cout << " sqrtS / sigma " << sqrtS/GeV << " / " <<
+		//          sigma/millibarn << G4endl;
 	    }
 	}
@@ -181,13 +181,13 @@
   G4bool dummy = false;
   G4int i;
-  G4String key = G4Proton::ProtonDefinition()->GetParticleName();
+  G4ParticleDefinition * key = G4Proton::ProtonDefinition();
   G4PhysicsVector* pp = 0;
 
-  typedef std::map <G4String, G4PhysicsVector*, std::less<G4String> > StringPhysMap;
+  typedef std::map <G4ParticleDefinition *, G4PhysicsVector*, std::less<G4ParticleDefinition *> > StringPhysMap;
   StringPhysMap::const_iterator iter;
 
   for (iter = xMap.begin(); iter != xMap.end(); ++iter)
     {
-      G4String str = (*iter).first;
+      G4ParticleDefinition * str = (*iter).first;
       if (str == key)
 	{
@@ -210,9 +210,9 @@
   G4cout << Name() << ", np cross-section: " << G4endl;
 
-  key = G4Neutron::NeutronDefinition()->GetParticleName();
+  key = G4Neutron::NeutronDefinition();
   G4PhysicsVector* np = 0;
   for (iter = xMap.begin(); iter != xMap.end(); ++iter)
     {
-      G4String str = (*iter).first;
+      G4ParticleDefinition * str = (*iter).first;
       if (str == key)
 	{
Index: trunk/source/processes/hadronic/models/im_r_matrix/src/G4XNNTotalLowE.cc
===================================================================
--- trunk/source/processes/hadronic/models/im_r_matrix/src/G4XNNTotalLowE.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/im_r_matrix/src/G4XNNTotalLowE.cc	(revision 1228)
@@ -65,6 +65,6 @@
       it.second=npTot[i]; np->push_back(it);
     }
-  theCrossSections[G4Proton::ProtonDefinition()->GetParticleName()] = pp;
-  theCrossSections[G4Neutron::NeutronDefinition()->GetParticleName()] = np;
+  theCrossSections[G4Proton::ProtonDefinition()] = pp;
+  theCrossSections[G4Neutron::NeutronDefinition()] = np;
 }
 
@@ -72,9 +72,7 @@
 G4XNNTotalLowE::~G4XNNTotalLowE()
 {
-  G4String name_proton = "proton";
-  G4String name_neutron = "neutron";
   
-  delete theCrossSections[name_proton];
-  delete theCrossSections[name_neutron];
+  delete theCrossSections[G4Proton::ProtonDefinition()];
+  delete theCrossSections[G4Neutron::NeutronDefinition()];
 }
 
@@ -83,5 +81,5 @@
   G4double result = 0.;
   G4double sqrtS = (trk1.Get4Momentum() + trk2.Get4Momentum()).mag();
-  G4String key = FindKeyParticle(trk1,trk2);
+  G4ParticleDefinition * key = FindKeyParticle(trk1,trk2);
 
   if (theCrossSections.find(key)!= theCrossSections.end())
